unit cnvtypes;

interface
// File converter API
// cnvEnymFormats must return on nFormatId=0 the number of supported formats
// on each nFormatId from 1 to MaxFormats it returns the description of file format
// and its flag
// Description = 'string1|string2'
// string1 - textual description of file format
// string2 - file extension filter in style *.ext1;*.ext2;*.extN
// flags - ored combination of FLAG_xxxx
// bufsize - size of buffer actually occupied by string + 0-terminator
// all function can be called in arbitraty thread context
type
  TcnvInit=function(const intf:pointer):integer;stdcall;
	TcnvImport=function(nFormatId:integer; const FileName:PChar;hSp:pointer):integer;stdcall;
  TcnvImportEx=function(nFormatId:integer; const FileName:PChar;uc:IUnknown):integer;stdcall;
	TcnvExport=function(nFormatId:integer; const FileName:PChar;hSp:pointer):integer;stdcall;
  TcnvExportEx=function(nFormatId:integer; const FileName:PChar;uc:IUnknown):integer;stdcall;
	TcnvEnumFormats=function(nFormatId:integer;FormatName:PCHAR;var bufsize:integer;var flags:integer):integer;stdcall;

const
  FLAG_READ   = 1;
  FLAG_WRITE  = 2;
  FLAG_IMPORT = 4;
  FLAG_EXPORT = 8;

  // Technique flags
  FLAG_SPECTRA = $00010000;

  FLAGS_READWRITE = FLAG_READ or FLAG_WRITE;
  FLAGS_IMPEXP    = FLAG_IMPORT or FLAG_EXPORT;

  CNV_OK = 1;
  CNV_FAIL = 0;

function convflags(flg:integer):string;
function convname(const cnv:string):string;
function convext(const cnv:string):string;

implementation

function convflags(flg:integer):string;
begin
	Result:='';
	if flg and FLAG_READ<>0 then
		Result:=Result+'R';
	if flg and FLAG_WRITE<>0 then
		Result:=Result+'W';
	if flg and FLAG_IMPORT<>0 then
		Result:=Result+'I';
	if flg and FLAG_EXPORT<>0 then
		Result:=Result+'E';
end;

function convname(const cnv:string):string;
begin
	Result:=copy(cnv,1,pos('|',cnv)-1);
end;

function convext(const cnv:string):string;
begin
	Result:=copy(cnv,pos('|',cnv)+1,length(cnv));
end;

end.
