#ifndef __devtypes__
#define __devtypes__

//////////////////////////////////////////////////////////////////////////
// $1.0 (C) 1992-2003 New Analytical Systems Ltd.
// This is cool include file for all UniChrom driver data types and prototypes
// The file is provided AS IS without any warranties expressed or implied
//////////////////////////////////////////////////////////////////////////

#ifdef __cplusplus
extern "C" {
#endif

#pragma pack(push,4)


const dsNormal=0;
const dsIdle = dsNormal;

const dsPreparing = 1;
const dsPrerun = dsPreparing;

const dsStarted=2;
const dsStarting=dsStarted;
const dsRun=dsStarted;
  
const dsPostrun=3;
const dsCooling=4;

const dsShowMisc=128;

  // in-data status bits (MSB byte in 4-byte data) for block callback
const bdsStarting = 0x20;
const ldsStarting = 0x20000000;
const bdsRange    = 0x40;
const ldsRange    = 0x40000000;

  // Old: type of device/callback - obsolete in further
const dtBlockData=1;
const dtPointData=2;
const dtTemporal =4;
const dtSpatial  =8;
const dtCalibrate=16;
const dtWriteable=32;
  

  // Old: GC heating zones indices
const hzNone=-1;
const hzOven=0;
const hzDetA=1;
const hzInjA=2;
const hzInjB=3;
const hzDetB=4;
const hzAux1=5;
const hzAux2=6;
const hzRes3=7;

  // New GC zone indices
const zNone =-1;
const zOven = 0;

const zInj = 0x10000;
const zInjA=zInj;
const zInjB=zInj+1;
const zInjC=zInj+2;
const zInjD=zInj+3;

const zDet=0x20000;
const zDetA=zDet;
const zDetB=zDet+1;
const zDetC=zDet+2;
const zDetD=zDet+3;

const zAux=0x30000;
const zAux1=zAux;
const zAux2=zAux+1;
const zAux3=zAux+2;

const zValueType=0x7FFF0000;
const zValueIndex=0xFFFF;
const zTypeShift=16;
const ztOven=0;
const ztInj=1;
const ztDet=2;
const ztAux=3;
  
// Old: temp zone parameters
const tzT_0=0;
const tzT_x=1;
const tzTmax=2;

// Old: flow zone parameters
const fzF1_0=3;
const fzF1_x=4;  
const fzF1max=5;

const fzF2_0=6;
const fzF2_x=7;
const fzF2max=8;
const fzF3_0=9;
const fzF3_x=10;
const fzF3max=11;

// Old: gaz type parameters
const fzGT1 = 21;
const fzGT2 = 22;
const fzGT3 = 23;

/*      | DetA      InjA  InjB  DetB
   -----+-------------------------------
   Gaz1 | MakeUp    Car   Car   MakeUp
   Gaz2 | Hydrogen  Spl   Spl   Hydrogen
   Gaz3 | Air       Sept  Sept  Air
*/

const fzCarrGas = 21; //for injector/column
const fzCarrGaz = fzCarrGas;

// Old: detector state parameter
const zzLight = 1001;



// New GC zoneObject indices
const zoNone=-1;
const zoTemp=0;
const zoFlow=0x10000;
const zoFlowA=zoFlow;
const zoFlowB=zoFlow+1;
const zoFlowC=zoFlow+2;

const zoPres=0x20000;
const zoPresA=zoPres;
const zoPresB=zoPres+1;
const zoPresC=zoPres+2;

const zoVel=0x30000;
const zoVelA=zoVel;
const zoVelB=zoVel+1;
const zoVelC=zoVel+2;

const zotTemp=0;
const zotFlow=1;
const zotPres=2;
const zotVel =3;

// New GC objectParameter indices
const opNone    = -1;
const opMin     = 0;
const opMax     = 1;
const opSet     = 2;
const opCur     = 3;
const opDrift   = 4;
const opGas     = 5;
const opProg    = 6;
const opName    = 7;
const opLight   = 8;
const opEnabled = 9;
const opMode    = 10;
const opColLen  = 11;
const opColIDm  = 12;
const opType    = 13;

  

// Old: gas types

const gcfNone     = -1;
const gcfUnknown  = 0;
const gcfNitrogen = 1;
const gcfArgon    = 2;
const gcfHelium   = 3;
const gcfHydrogen = 4;
const gcfAir      = 5;
const gcfOxygen   = 6;

// New: gas types

const gtNone     = -1;
const gtUnknown  = 0;
const gtNitrogen = 1;
const gtArgon    = 2;
const gtHelium   = 3;
const gtHydrogen = 4;
const gtAir      = 5;
const gtOxygen   = 6;
const gtArgonMethane = 7;

// Light state

const ltNone = -1;
const ltUnknown = 0;
const ltOff = 1;
const ltOn = 2;

// LC control zone indices
const lczPumpA = 0;
const lczPumpB = 1;
const lczPumpC = 2;
const lczPumpD = 3;
const lczPress = 4;

// LC zone param inidices
const lcF_0  = 1;
const lcF_x  = 2;
const lcFmax = 3;
const lcPmin = 4;
const lcPmax = 5;
const lcP_x  = 6;
const lcOnline = 7;
const lcCurTime = 8;
const lcAlarm = 9;
const lcPumpType = 10; // type of a pump - 0 - plunger 1 - syringe 




// Old: notify indexes
// new also
const rnAll		=-1;
const rnStart	=-2;
const rnStop	=-3;
const rnReady	=-4;
const rnSeqFinish = -5;
const rnReconfig = -100;



// Invalid values
const InvalidZoneValue = -1000;

typedef HANDLE IHandle;

// Device Info Structure
struct TDeviceInfo
{
	int	DevType;
  int FullScale;
  float DevMin;
  float DevMax;
};


//Additional types
typedef int TIntArray[];
typedef TIntArray* PIntArray;

typedef DWORD TDWordArray[];
typedef TDWordArray* PDWordArray;

typedef __int64 TQWordArray[];
typedef TQWordArray* PQWordArray;

typedef float TFloatArray[];
typedef TFloatArray* PFloatArray;

typedef double TDoubleArray[];
typedef TDoubleArray* PDoubleArray;
  
//Program callback types
#define UCAPI __stdcall

typedef void (UCAPI *TPointCallback)(void* Self,int data, int stat);
typedef void (UCAPI *TBlockCallback)(void* Self,PIntArray PBuf,int cbLen);
typedef void (UCAPI *TInt32Callback)(void* Self,PDWordArray PData, int cbLen, int stat);

typedef void (UCAPI *TInt64Callback)(void* Self,PQWordArray PData,int cbLen,int stat);
typedef void (UCAPI *TFloatCallback)(void* Self,PFloatArray PData,int cbLen,int stat);

typedef void (UCAPI *TDoubleCallback)(void* Self,PDoubleArray PData,int cbLen,int stat);

typedef void (UCAPI *TPageNotify)(void* Client,int npage, int hDevice);
//new name
typedef void (UCAPI *TNotify)(void* Client,int AZone,IHandle HInstrument);

typedef void (UCAPI *TDebugWriteStr)(void* Client,PCHAR PStr);



struct TObjectFunction 
{
	void* AFunction;
	void* AClient;
};

typedef TObjectFunction* PObjectFunction;

//Client Info Structure
struct TPointClient
{
	TPointCallback Action;
  void* Client;
  int Profile;
  int BaseAddr;
};

struct TClient
{
  TInt32Callback Action;
  void* Client;
};


struct TClientEx
{
  TInt32Callback Action;
  void* Client;
  float Frequency;
};

typedef struct TRampRec
{
  int index;
  float fTempRate,fFinalTemp,fIsoTime;
} *PRampRec;


typedef struct TRamp
{
  float ValRate,FinalVal,IsoTime;
} *PRamp;

typedef struct TFlowRec
{
  int index;
  double Time,Flow,Flow1,Flow2,Flow3,Flow4;
} *PFlowRec;

typedef struct TPumpRamp
{
  double Time,Flow,Flow1,Flow2,Flow3,Flow4;
} *PPumpRamp;

// User Device service functions
// this can be used as prototypes for driver dynamic import
typedef BOOL (UCAPI *TdrvOpen)();
typedef BOOL (UCAPI *TdrvClose)();
typedef BOOL (UCAPI *TdrvOpenPointChannel)(TPointCallback AnAction,void* AClient, int AChannel);
typedef BOOL (UCAPI *TdrvOpenBlockChannel)(TBlockCallback AnAction,void* AClient, int AChannel);
typedef BOOL (UCAPI *TdrvCloseChannel)(int AChannel);
typedef BOOL (UCAPI *TdrvGetDevInfo)(TDeviceInfo* DevInfo);
typedef float (UCAPI *TdrvGetResolution)();
typedef BOOL (UCAPI *TdrvSetFrequency)(float* freq);
typedef double (UCAPI *TdrvCalibrate)(int AChannel,double Adata);
typedef BOOL (UCAPI *TdrvWriteDevice)(const void* Buf, int cbBuf);

//new instrumental functions
typedef BOOL (UCAPI *TdrvOpenEx)(TDebugWriteStr ADebugFunction,void* AClient);
typedef int (UCAPI *TdrvOpenInstrument)(int AProfile,TPageNotify AnAction,void* AClient);
typedef BOOL (UCAPI *TdrvCloseInstrument)(int HInstrument);
typedef BOOL (UCAPI *TdrvOpenPointChannelEx)(IHandle HInstrument,TPointCallback AnAction,void* AClient,int AChannel);
typedef BOOL (UCAPI *TdrvOpenBlockChannelEx)(IHandle HInstrument,TBlockCallback AnAction,void* AClient,int AChannel);
typedef BOOL (UCAPI *TdrvOpenInt32ChannelEx)(IHandle HInstrument,TInt32Callback AnAction,void* AClient,int AChannel);
typedef BOOL (UCAPI *TdrvOpenInt64ChannelEx)(IHandle HInstrument,TInt64Callback AnAction,void* AClient,int AChannel);
typedef BOOL (UCAPI *TdrvOpenFloatChannelEx)(IHandle HInstrument,TFloatCallback AnAction,void* AClient,int AChannel);
typedef BOOL (UCAPI *TdrvOpenDoubleChannelEx)(IHandle HInstrument,TDoubleCallback AnAction,void* AClient,int AChannel);

typedef BOOL (UCAPI *TdrvCloseChannelEx)(IHandle HInstrument,int AChannel);
typedef BOOL (UCAPI *TdrvGetChannelInfo)(IHandle HInstrument,int AChannel,TDeviceInfo* DevInfo);
typedef float (UCAPI *TdrvGetChannelFrequency)(IHandle HInstrument,int AChannel);
typedef float (UCAPI *TdrvSetChannelFrequency)(IHandle HInstrument,int AChannel,float freq);
typedef double (UCAPI *TdrvChannelCalibrate)(IHandle HInstrument,int AChannel,double Adata);
typedef BOOL (UCAPI *TdrvSetState)(IHandle HInstrument,int AState);
typedef int (UCAPI *TdrvGetState)(IHandle HInstrument);

//Internal Device usage
typedef TPointClient TCallbackList[];
typedef TCallbackList TPointCallbackList;
 
typedef TCallbackList* PCallbackList;
typedef TPointCallbackList*  PPointCallbackList;
  
typedef TClientEx TClients[];
typedef TClients* PClients;
  

typedef long double extended;

// Instrument control api
typedef TdrvOpenInstrument TtcbInitialize;
typedef TdrvCloseInstrument TtcbDone;
typedef BOOL (UCAPI *TtcbSetZoneValue)(int hnd,int zone,int ndx,extended val);
typedef extended (UCAPI *TtcbGetZoneValue)(int hnd,int zone,int ndx);

typedef BOOL (UCAPI *TtcbSetTempRec)(int hnd,int ndx,PRampRec Prec);

typedef TdrvSetState TtcbStartStop;

// new instrument control api
typedef BOOL (UCAPI *TtcbSetZoneValueEx)(IHandle HInstrument,int AZone,int AZoneObject,int AParamIndex,extended AValue);
typedef extended (UCAPI TtcbGetZoneValueEx)(IHandle HInstrument,int AZone,int AZoneObject,int AParamIndex);
typedef BOOL (UCAPI *TtcbCheckReadZoneValue)(IHandle HInstrument,int AZone,int AZoneObject,int AParamIndex);
typedef BOOL (UCAPI *TtcbCheckWriteZoneValue)(IHandle HInstrument,int AZone,int AZoneObject,int AParamIndex);
typedef BOOL (UCAPI *TtcbSetProgRamp)(IHandle HInstrument,int AZone,int AZoneObject,int ARampIndex,PRamp PRec);
typedef BOOL (UCAPI *TtcbGetProgRamp)(IHandle HInstrument,int AZone,int AZoneObject,int ARampIndex,PRamp PRec);


// Flow api
typedef TdrvOpenInstrument TfcbInitialize;
typedef TdrvCloseInstrument TfcbDone;
typedef BOOL (UCAPI *TfcbSetRec)(int hnd,int ndx,PFlowRec Prec);

// new flow api
typedef BOOL (UCAPI *TfcbSetRecEx)(IHandle HInstrument,int AZone,int AZoneObject,PFlowRec PRec);

///////////////////////////////////
// the very new Autosampler API
///////////////////////////////////
typedef int (UCAPI *TsmpGetParam)(IHandle HInstrument,int ATower,int AParamIndex);
typedef BOOL (UCAPI *TsmpSetParam)(IHandle HInstrument,int ATower,int AParamIndex,int AParam);

typedef BOOL (UCAPI *TsmpSetSample)(IHandle HInstrument,int ASamp,int ATower,int AVial,int ACount,int AVolume);
typedef int (UCAPI *TsmpGetSample)(IHandle HInstrument,int ASamp,int AParamIndex);

typedef BOOL (UCAPI *TevtSetParam)(IHandle HInstrument,int AEvent,int AParamIndex,int AParam);
typedef int (UCAPI *TevtGetParam)(IHandle HInstrument,int AEvent,int AParamIndex);

// indices for getting parameters of
// choosen sample
// e.g. smpGetParam(hInst,1,1,smpiPos) - get the tray position of 1-st sample in sequence
// samples are 1-bases
// towers are 1-based
const twiAny = -1;
const ssAny  = twiAny;

const twiValves = -2;

// used for getting information on sampling system in total

// indices for getting total information on sampling system
// smpGetParam(hInst,twiAny,smpnInfo,smpiStatus)   - get the number of installed towers
// smpGetParam(hInst,2,smpnInfo,smpiStatus) - get the status of second tower
const smpiStatus   = -1;  //the number of installed towers
const smpiTowerMax = -2; // the number of positions for tower
const smpiTotal		 = -3; // total number of samples

const smpiInjectionSource = 1;

const smpManual = 0;
const smpALS		= 1;
const smpValve	= 2;

// Sampling system parameters
const smpiSolventWash = -4; // number or time of washing
const smpiSamplePump	= -5; // number or time of sample pumping
const smpiInjSpeed		= -6; // speed or time of sample injection
const smpiLoadSpeed		= -7;	// speed or time of sample loading
const smpiDwellTime		= -8; // dwelling time in injector

// HP6890-added parameters
const smpiSolventAPreWash    = smpiSolventWash;
const smpiSolventBPreWash    = -9; //number or time of washing...
const smpiSolventAPostWash   = -10; // ...in two solvents...
const smpiSolventBPostWash   = -11; // ...before and after injection

const smpiSamplePreWash      = -12; // washing in sample before injection??
  //smpiSamplePump       = -5; // number or time of sample pumping
  //smpiInjSpeed         = -6; // speed or time of sample injection (0 or 1 for HP)
const smpiViscosityDelay     = smpiLoadSpeed;
const smpiPreInjectionDwell  = smpiDwellTime; // dwelling times in injector...
const smpiPostInjectionDwell = -13; // before and after injection, in 0.01 mins (0-100)
const smpiSampleSkimDepth    = -14; // skim??

// indices for getting sample parameters
const smpiTower		 	= 0; // max number of samples in sequence
const smpiPos		 		= 1; // position of chosen sample in tray
const smpiVolume 		= 2; // injection volume of chosen sample
const smpiCount			= 3; // number of injection


  // generic get/set valve info
const vpiValve   = 1000;  // number of referenced valve
const vpiType    = 1001;  // type of referenced valve
const vpiInlet   = 1002;  // inlet to which referenced valve is connected
const vpiState   = 1003;  // state of referenced valve
const vpiTime    = 1004;  // time of valve event
const vpiVolume  = 1005;  // loop volume
const vpiLoadTime   = 1006;  // time for blowing sample loop with sample gas
const vpiInjectTime = 1007;  // time for connecting sample loop to inlet
const vpiCount	 = -1;

#ifdef __cplusplus
}
#endif

#pragma pack(pop)

#endif
// end of file
