

// spectrum management
// return the number of opened spectrums
function GetNspec:integer;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

// returns the spectrum by its index (from 0 to Count - 1)
//   GetASpec!
//   , HINVALID  
//  Exception "Access violation"
function GetAspec(num:integer):HSpec;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

function CreateSpec: hSpec; stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

// find a spectrum by its name
function FindASpec(Aname:Pchar):HSpec;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

// open a spectrum from disk
function OpenSpec(FileName:PChar):HSpec;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

// close a selected spectrum
function CloseSpec(Sp:HSpec):longbool;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

// properties management
// get number of local or global properties
function GetNumProp(Sp:HSpec;isLocal:longbool):integer;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

// get property by its index
function GetPropByNdx(Sp:Hspec;isLocal:longbool;Ndx,cbbuf:integer;var buf):longbool;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

// set property by its index
function SetPropByNdx(Sp:Hspec;isLocal:longbool;Ndx:integer;Val:PChar):longbool;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

// get property by its name
function GetPropByName(Sp:HSpec;isLocal:longbool;Aname:PChar;cbbuf:integer;var buf):longbool;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

function GetPropByNameEx(Sp:HSpec;isLocal:longbool;Aname:PChar;cbbuf:integer;var buftype:integer;var buf):longbool;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

// if nlay=-1 return global property
//   GetPropValue!
// GetPropValue   , 
//    ,     , ..
// (ASpec <> HINVALID) and (ASpec is destroyed)
//  Exception "Access violation"
function GetPropValue(Sp:HSpec;nlay:integer;Aname:PChar;var val:Variant):longbool;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}
function SetPropValue(Sp:HSpec;nlay:integer;Aname:PChar;val:Variant):longbool;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

// set property by its name
function SetPropByName(Sp:HSpec;isLocal:longbool;Aname:PChar;Val:PChar):longbool;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}
//function SetPropByNameEx(Sp:HSpec;isLocal:bool;Aname:PChar;cbbuf,buftype:integer;const buf):bool;stdcall;

// peaks and lays management

// get number of layers
function GetNLays(Sp:HSpec):integer;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

// get number of peak in layer
// "lay" is an index of lay but not it's a number
function GetNPeaks(Sp:HSpec;lay:integer):integer;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

// get peak handle
function GetPeak(Sp:HSpec;lay,ndx:integer):HPeak;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

// get parameter of peak
function GetPeakParam(Apk:Hpeak;parndx:integer;var buftype:integer;var buf):longbool;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}
function GetPeakParamEx(Apk:Hpeak;parndx:integer;var buf:variant):longbool;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

// set peak parameter
function SetPeakParam(Apk:Hpeak;parndx,buftype:integer;const buf):longbool;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}
function SetPeakParamEx(Apk:Hpeak;parndx:integer;const buf:variant):longbool;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

// Data Layer management
//
function SetDataLayer(Asp:HSpec;aLay,nPoints,nPointSize:integer;var buf):boolean;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}
function GetDataLayer(Asp:HSpec;aLay:integer;var nPoints,nPointSize:integer;var buf):boolean;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

function SetData(Asp:HSpec;aLay,ndx:integer;AData:double):boolean;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}
function GetData(Asp:HSpec;aLay:integer;ndx:integer):double;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

function AddPeak(Asp:Hspec;aLay:integer;l,c,r:integer):HPeak;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

// Noise
function GetFNoise(Asp:Hspec;aLay:integer;hw,fb,fe:double):double;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}
function GetFNoiseBand(Asp:Hspec;aLay:integer;hw,fb,fe:double):double;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

// save or load
function StoreToStreamHandle(const AHandle:Thandle;ASpec:HSpec):boolean;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}
function LoadFromStreamHandle(const AHandle:Thandle;ASpec:HSpec):boolean;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

// picture
function GetPicture(ASpec:HSpec;lay,mmWidth,mmHeight:integer):boolean;stdcall;{$IFDEF _API_} external 'uwin32.exe';{$ENDIF}

