unit devtold;
// old device indices - use in conjunction with devtypes.pas
interface

uses devtypes;

type BOOL=longbool;
const
	// old bitmapped flags for device capabilities
	// Old: type of device/callback - obsolete in further
	dtBlockData=1;
	dtPointData=2;
	dtTemporal =4;
	dtSpatial  =8;
	dtCalibrate=16;
	dtWriteable=32;
	{dtInt32BData=64;
	dtInt64Data=128;}

	// Old: GC heating zones indices
	hzNone=-1;
	hzOven=0;
	hzDetA=1;
	hzInjA=2;
	hzInjB=3;
	hzDetB=4;
	hzAux1=5;
	hzAux2=6;
	hzRes3=7;


	// Old: gas types

	gcfNone     = -1;
	gcfUnknown  = 0;
	gcfNitrogen = 1;
	gcfArgon    = 2;
	gcfHelium   = 3;
	gcfHydrogen = 4;
	gcfAir      = 5;
	gcfOxygen   = 6;

	// Old: temp zone parameters
	tzT_0=0; tzT_x=1; tzTmax=2;

	// Old: flow zone parameters
	fzF1_0=3;  fzF1_x=4;  fzF1max=5;
	fzF2_0=6;  fzF2_x=7;  fzF2max=8;
	fzF3_0=9;  fzF3_x=10; fzF3max=11;

	// Old: gaz type parameters
	fzGT1 = 21;
	fzGT2 = 22;
	fzGT3 = 23;

	fzCarrGas = 21; //for injector/column
	fzCarrGaz = fzCarrGas;

	// Old: detector state parameter

	zzLight = 1001;


	// old LC control zone indices
	lczPumpA = 0;
	lczPumpB = 1;
	lczPumpC = 2;
	lczPumpD = 3;
	lczPress = 4;

	// old LC zone param inidices

	lcF_0  = 1;      // Flow setpoint
	lcFirst=lcF_0;
	lcF_x  = 2;      // Current flow
	lcFmax = 3;      // Max flow
	lcPmin = 4;      // Pressure min
	lcPmax = 5;      // Pressure max
	lcP_x  = 6;      // Current pressure
	lcOnline = 7;    // Pump State: 0=Stopped, 1=Pumping, 2=Loading
	lcCurTime = 8;   // Time from the begin of measure, ms
	lcAlarm = 9;     // Is OverPressure, or other problem
	lcPumpType = 10; // type of a pump - 0 - plunger 1 - syringe
	lcV_x 	= 11;    // Current pumped volume
	lcVmax	= 12;    // Max volume (volume to pump or to load)
	lcFin		=	13;    // pump loading speed (loading flow setpoint)
	lcT_0		= 14;    // Column temperature setpoint, C
	lcT_x		= 15;    // Current column temperature
	lcLast  = lcT_x; // fix this after adding new indices


type

	PRampRec=^TRampRec;
	TRampRec=record
		index:integer;
		fTempRate,fFinalTemp,fIsoTime:single;
	end;


	// User Device service functions
	TdrvOpen=function:BOOL;stdcall;
	TdrvClose=function:BOOL;stdcall;
	TdrvOpenPointChannel=function(AnAction:TPointCallback;AClient:pointer;AChannel:integer):BOOL;stdcall;
	TdrvOpenBlockChannel=function(AnAction:TBlockCallback;AClient:pointer;AChannel:integer):BOOL;stdcall;
	TdrvCloseChannel=function(AChannel:integer):BOOL;stdcall;
	TdrvGetDevInfo=function(var DevInfo:TDeviceInfo):BOOL;stdcall;
	TdrvGetResolution=function:single;stdcall;
	TdrvSetFrequency=function(var freq:single):BOOL;stdcall;
	TdrvCalibrate=function(AChannel:integer;Adata:double):double;stdcall;
	TdrvWriteDevice=function(const Buf;cbBuf:integer):BOOL;stdcall;

	// Temperature api
	TtcbInitialize=TdrvOpenInstrument;
	TtcbDone=TdrvCloseInstrument;
	TtcbSetZoneValue=function (hnd,zone,ndx:integer; val:extended):BOOL;stdcall;
	TtcbGetZoneValue=function (hnd,zone,ndx:integer):extended;stdcall;

	TtcbSetTempRec=function (hnd,ndx:integer;Prec:PRampRec):bool;stdcall;

	

implementation
end.
