#ifndef __devtypes__
#define __devtypes__

//////////////////////////////////////////////////////////////////////////
// $1.0 (C) 1992-2003 New Analytical Systems Ltd.
// This is cool include file for all UniChrom driver data types and prototypes
// The file is provided AS IS without any warranties expressed or implied
//////////////////////////////////////////////////////////////////////////

#ifdef __cplusplus
extern "C" {
#endif

#pragma pack(push,4)


const int dsNormal=0;
const int dsIdle = dsNormal;

const int dsPreparing = 1;
const int dsPrerun = dsPreparing;

const int dsStarted=2;
const int dsStarting=dsStarted;
const int dsRun=dsStarted;

const int dsPostrun=3;
const int dsCooling=4;

const int dsShowMisc=128;

  // in-data status bits (MSB byte in 4-byte data) for block callback
const long bdsStarting = 0x20;
const long ldsStarting = 0x20000000;
const long bdsRange    = 0x40;
const long ldsRange    = 0x40000000;

  // Old: type of device/callback - obsolete in further
const int dtBlockData=1;
const int dtPointData=2;
const int dtTemporal =4;
const int dtSpatial  =8;
const int dtCalibrate=16;
const int dtWriteable=32;


  // Old: GC heating zones indices
const int hzNone=-1;
const int hzOven=0;
const int hzDetA=1;
const int hzInjA=2;
const int hzInjB=3;
const int hzDetB=4;
const int hzAux1=5;
const int hzAux2=6;
const int hzRes3=7;

  // New GC zone indices
const int zNone =-1;
const int zOven = 0;

const int zInj = 0x10000;
const int zInjA=zInj;
const int zInjB=zInj+1;
const int zInjC=zInj+2;
const int zInjD=zInj+3;

const int zDet=0x20000;
const int zDetA=zDet;
const int zDetB=zDet+1;
const int zDetC=zDet+2;
const int zDetD=zDet+3;

const int zAux=0x30000;
const int zAux1=zAux;
const int zAux2=zAux+1;
const int zAux3=zAux+2;

const int zValueType=0x7FFF0000;
const int zValueIndex=0xFFFF;
const int zTypeShift=16;
const int ztOven=0;
const int ztInj=1;
const int ztDet=2;
const int ztAux=3;

// Old: temp zone parameters
const int tzT_0=0;
const int tzT_x=1;
const int tzTmax=2;

// Old: flow zone parameters
const int fzF1_0=3;
const int fzF1_x=4;
const int fzF1max=5;

const int fzF2_0=6;
const int fzF2_x=7;
const int fzF2max=8;
const int fzF3_0=9;
const int fzF3_x=10;
const int fzF3max=11;

// Old: gaz type parameters
const int fzGT1 = 21;
const int fzGT2 = 22;
const int fzGT3 = 23;

/*      | DetA      InjA  InjB  DetB
   -----+-------------------------------
   Gaz1 | MakeUp    Car   Car   MakeUp
   Gaz2 | Hydrogen  Spl   Spl   Hydrogen
   Gaz3 | Air       Sept  Sept  Air
*/

const int fzCarrGas = 21; //for injector/column
const int fzCarrGaz = fzCarrGas;

// Old: detector state parameter
const int zzLight = 1001;



// New GC zoneObject indices
const int zoNone=-1;
const int zoTemp=0;
const int zoFlow=0x10000;
const int zoFlowA=zoFlow;
const int zoFlowB=zoFlow+1;
const int zoFlowC=zoFlow+2;

const int zoPres=0x20000;
const int zoPresA=zoPres;
const int zoPresB=zoPres+1;
const int zoPresC=zoPres+2;

const int zoVel=0x30000;
const int zoVelA=zoVel;
const int zoVelB=zoVel+1;
const int zoVelC=zoVel+2;

const int zotTemp=0;
const int zotFlow=1;
const int zotPres=2;
const int zotVel =3;

// New GC objectParameter indices
const int opNone    = -1;
const int opMin     = 0;
const int opMax     = 1;
const int opSet     = 2;
const int opCur     = 3;
const int opDrift   = 4;
const int opGas     = 5;
const int opProg    = 6;
const int opName    = 7;
const int opLight   = 8;
const int opEnabled = 9;
const int opMode    = 10;
const int opColLen  = 11;
const int opColIDm  = 12;
const int opType    = 13;



// Old: gas types

const int gcfNone     = -1;
const int gcfUnknown  = 0;
const int gcfNitrogen = 1;
const int gcfArgon    = 2;
const int gcfHelium   = 3;
const int gcfHydrogen = 4;
const int gcfAir      = 5;
const int gcfOxygen   = 6;

// New: gas types

const int gtNone     = -1;
const int gtUnknown  = 0;
const int gtNitrogen = 1;
const int gtArgon    = 2;
const int gtHelium   = 3;
const int gtHydrogen = 4;
const int gtAir      = 5;
const int gtOxygen   = 6;
const int gtArgonMethane = 7;

// Light state

const int ltNone = -1;
const int ltUnknown = 0;
const int ltOff = 1;
const int ltOn = 2;

// LC control zone indices
const int lczPumpA = 0;
const int lczPumpB = 1;
const int lczPumpC = 2;
const int lczPumpD = 3;
const int lczPress = 4;

// LC zone param inidices
const int lcF_0  = 1;
const int lcF_x  = 2;
const int lcFmax = 3;
const int lcPmin = 4;
const int lcPmax = 5;
const int lcP_x  = 6;
const int lcOnline = 7;
const int lcCurTime = 8;
const int lcAlarm = 9;
const int lcPumpType = 10; // type of a pump - 0 - plunger 1 - syringe




// Old: notify indexes
// new also
const int rnAll		=-1;
const int rnStart	=-2;
const int rnStop	=-3;
const int rnReady	=-4;
const int rnSeqFinish = -5;
const int rnReconfig = -100;



// Invalid values
const int InvalidZoneValue = -1000;


#ifdef __GNUC__
typedef int HANDLE;
typedef unsigned int DWORD;

typedef long long int	__int64;
#endif

typedef HANDLE IHandle;

// Device Info Structure
struct TDeviceInfo
{
	int	DevType;
  int FullScale;
  float DevMin;
  float DevMax;
};


//Additional types
typedef int TIntArray[1000];
typedef TIntArray* PIntArray;

typedef DWORD TDWordArray[1000];
typedef TDWordArray* PDWordArray;

typedef __int64 TQWordArray[1000];
typedef TQWordArray* PQWordArray;

typedef float TFloatArray[1000];
typedef TFloatArray* PFloatArray;

typedef double TDoubleArray[1000];
typedef TDoubleArray* PDoubleArray;

//Program callback types
#ifdef __GNUC__
    #define UCAPI __attribute__((stdcall))
#else
    #define UCAPI __stdcall
#endif


typedef void (UCAPI *TPointCallback)(void* Self,int data, int stat);
typedef void (UCAPI *TBlockCallback)(void* Self,PIntArray PBuf,int cbLen);
typedef void (UCAPI *TInt32Callback)(void* Self,PDWordArray PData, int cbLen, int stat);

typedef void (UCAPI *TInt64Callback)(void* Self,PQWordArray PData,int cbLen,int stat);
typedef void (UCAPI *TFloatCallback)(void* Self,PFloatArray PData,int cbLen,int stat);

typedef void (UCAPI *TDoubleCallback)(void* Self,PDoubleArray PData,int cbLen,int stat);

typedef void (UCAPI *TPageNotify)(void* Client,int npage, int hDevice);
//new name
typedef void (UCAPI *TNotify)(void* Client,int AZone,IHandle HInstrument);

typedef void (UCAPI *TDebugWriteStr)(void* Client,PCHAR PStr);



struct TObjectFunction
{
	void* AFunction;
	void* AClient;
};

typedef TObjectFunction* PObjectFunction;

//Client Info Structure
struct TPointClient
{
	TPointCallback Action;
  void* Client;
  int Profile;
  int BaseAddr;
};

struct TClient
{
  TInt32Callback Action;
  void* Client;
};


struct TClientEx
{
  TInt32Callback Action;
  void* Client;
  float Frequency;
};

typedef struct TRampRec
{
  int index;
  float fTempRate,fFinalTemp,fIsoTime;
} *PRampRec;


typedef struct TRamp
{
  float ValRate,FinalVal,IsoTime;
} *PRamp;

typedef struct TFlowRec
{
  int index;
  double Time,Flow,Flow1,Flow2,Flow3,Flow4;
} *PFlowRec;

typedef struct TPumpRamp
{
  double Time,Flow,Flow1,Flow2,Flow3,Flow4;
} *PPumpRamp;

// User Device service functions
// this can be used as prototypes for driver dynamic import
typedef BOOL (UCAPI *TdrvOpen)();
typedef BOOL (UCAPI *TdrvClose)();
typedef BOOL (UCAPI *TdrvOpenPointChannel)(TPointCallback AnAction,void* AClient, int AChannel);
typedef BOOL (UCAPI *TdrvOpenBlockChannel)(TBlockCallback AnAction,void* AClient, int AChannel);
typedef BOOL (UCAPI *TdrvCloseChannel)(int AChannel);
typedef BOOL (UCAPI *TdrvGetDevInfo)(TDeviceInfo* DevInfo);
typedef float (UCAPI *TdrvGetResolution)();
typedef BOOL (UCAPI *TdrvSetFrequency)(float* freq);
typedef double (UCAPI *TdrvCalibrate)(int AChannel,double Adata);
typedef BOOL (UCAPI *TdrvWriteDevice)(const void* Buf, int cbBuf);

//new instrumental functions
typedef BOOL (UCAPI *TdrvOpenEx)(TDebugWriteStr ADebugFunction,void* AClient);
typedef int (UCAPI *TdrvOpenInstrument)(int AProfile,TPageNotify AnAction,void* AClient);
typedef BOOL (UCAPI *TdrvCloseInstrument)(int HInstrument);
typedef BOOL (UCAPI *TdrvOpenPointChannelEx)(IHandle HInstrument,TPointCallback AnAction,void* AClient,int AChannel);
typedef BOOL (UCAPI *TdrvOpenBlockChannelEx)(IHandle HInstrument,TBlockCallback AnAction,void* AClient,int AChannel);
typedef BOOL (UCAPI *TdrvOpenInt32ChannelEx)(IHandle HInstrument,TInt32Callback AnAction,void* AClient,int AChannel);
typedef BOOL (UCAPI *TdrvOpenInt64ChannelEx)(IHandle HInstrument,TInt64Callback AnAction,void* AClient,int AChannel);
typedef BOOL (UCAPI *TdrvOpenFloatChannelEx)(IHandle HInstrument,TFloatCallback AnAction,void* AClient,int AChannel);
typedef BOOL (UCAPI *TdrvOpenDoubleChannelEx)(IHandle HInstrument,TDoubleCallback AnAction,void* AClient,int AChannel);

typedef BOOL (UCAPI *TdrvCloseChannelEx)(IHandle HInstrument,int AChannel);
typedef BOOL (UCAPI *TdrvGetChannelInfo)(IHandle HInstrument,int AChannel,TDeviceInfo* DevInfo);
typedef float (UCAPI *TdrvGetChannelFrequency)(IHandle HInstrument,int AChannel);
typedef float (UCAPI *TdrvSetChannelFrequency)(IHandle HInstrument,int AChannel,float freq);
typedef double (UCAPI *TdrvChannelCalibrate)(IHandle HInstrument,int AChannel,double Adata);
typedef BOOL (UCAPI *TdrvSetState)(IHandle HInstrument,int AState);
typedef int (UCAPI *TdrvGetState)(IHandle HInstrument);

//Internal Device usage
typedef TPointClient TCallbackList[];
typedef TCallbackList TPointCallbackList;

typedef TCallbackList* PCallbackList;
typedef TPointCallbackList*  PPointCallbackList;

typedef TClientEx TClients[];
typedef TClients* PClients;


typedef long double extended;

// Instrument control api
typedef TdrvOpenInstrument TtcbInitialize;
typedef TdrvCloseInstrument TtcbDone;
typedef BOOL (UCAPI *TtcbSetZoneValue)(int hnd,int zone,int ndx,extended val);
typedef extended (UCAPI *TtcbGetZoneValue)(int hnd,int zone,int ndx);

typedef BOOL (UCAPI *TtcbSetTempRec)(int hnd,int ndx,PRampRec Prec);

typedef TdrvSetState TtcbStartStop;

// new instrument control api
typedef BOOL (UCAPI *TtcbSetZoneValueEx)(IHandle HInstrument,int AZone,int AZoneObject,int AParamIndex,extended AValue);
typedef extended (UCAPI TtcbGetZoneValueEx)(IHandle HInstrument,int AZone,int AZoneObject,int AParamIndex);
typedef BOOL (UCAPI *TtcbCheckReadZoneValue)(IHandle HInstrument,int AZone,int AZoneObject,int AParamIndex);
typedef BOOL (UCAPI *TtcbCheckWriteZoneValue)(IHandle HInstrument,int AZone,int AZoneObject,int AParamIndex);
typedef BOOL (UCAPI *TtcbSetProgRamp)(IHandle HInstrument,int AZone,int AZoneObject,int ARampIndex,PRamp PRec);
typedef BOOL (UCAPI *TtcbGetProgRamp)(IHandle HInstrument,int AZone,int AZoneObject,int ARampIndex,PRamp PRec);


// Flow api
typedef TdrvOpenInstrument TfcbInitialize;
typedef TdrvCloseInstrument TfcbDone;
typedef BOOL (UCAPI *TfcbSetRec)(int hnd,int ndx,PFlowRec Prec);

// new flow api
typedef BOOL (UCAPI *TfcbSetRecEx)(IHandle HInstrument,int AZone,int AZoneObject,PFlowRec PRec);

///////////////////////////////////
// the very new Autosampler API
///////////////////////////////////
typedef int (UCAPI *TsmpGetParam)(IHandle HInstrument,int ATower,int AParamIndex);
typedef BOOL (UCAPI *TsmpSetParam)(IHandle HInstrument,int ATower,int AParamIndex,int AParam);

typedef BOOL (UCAPI *TsmpSetSample)(IHandle HInstrument,int ASamp,int ATower,int AVial,int ACount,int AVolume);
typedef int (UCAPI *TsmpGetSample)(IHandle HInstrument,int ASamp,int AParamIndex);

typedef BOOL (UCAPI *TevtSetParam)(IHandle HInstrument,int AEvent,int AParamIndex,int AParam);
typedef int (UCAPI *TevtGetParam)(IHandle HInstrument,int AEvent,int AParamIndex);

// indices for getting parameters of
// choosen sample
// e.g. smpGetParam(hInst,1,1,smpiPos) - get the tray position of 1-st sample in sequence
// samples are 1-bases
// towers are 1-based
const int twiAny = -1;
const int ssAny  = twiAny;

const int twiValves = -2;

// used for getting information on sampling system in total

// indices for getting total information on sampling system
// smpGetParam(hInst,twiAny,smpnInfo,smpiStatus)   - get the number of installed towers
// smpGetParam(hInst,2,smpnInfo,smpiStatus) - get the status of second tower
const int smpiStatus   = -1;  //the number of installed towers
const int smpiTowerMax = -2; // the number of positions for tower
const int smpiTotal		 = -3; // total number of samples

const int smpiInjectionSource = 1;

const int smpManual = 0;
const int smpALS		= 1;
const int smpValve	= 2;

// Sampling system parameters
const int smpiSolventWash = -4; // number or time of washing
const int smpiSamplePump	= -5; // number or time of sample pumping
const int smpiInjSpeed		= -6; // speed or time of sample injection
const int smpiLoadSpeed		= -7;	// speed or time of sample loading
const int smpiDwellTime		= -8; // dwelling time in injector

// HP6890-added parameters
const int smpiSolventAPreWash    = smpiSolventWash;
const int smpiSolventBPreWash    = -9; //number or time of washing...
const int smpiSolventAPostWash   = -10; // ...in two solvents...
const int smpiSolventBPostWash   = -11; // ...before and after injection

const int smpiSamplePreWash      = -12; // washing in sample before injection??
  //smpiSamplePump       = -5; // number or time of sample pumping
  //smpiInjSpeed         = -6; // speed or time of sample injection (0 or 1 for HP)
const int smpiViscosityDelay     = smpiLoadSpeed;
const int smpiPreInjectionDwell  = smpiDwellTime; // dwelling times in injector...
const int smpiPostInjectionDwell = -13; // before and after injection, in 0.01 mins (0-100)
const int smpiSampleSkimDepth    = -14; // skim??

// indices for getting sample parameters
const int smpiTower		 	= 0; // max number of samples in sequence
const int smpiPos		 		= 1; // position of chosen sample in tray
const int smpiVolume 		= 2; // injection volume of chosen sample
const int smpiCount			= 3; // number of injection


  // generic get/set valve info
const int vpiValve   = 1000;  // number of referenced valve
const int vpiType    = 1001;  // type of referenced valve
const int vpiInlet   = 1002;  // inlet to which referenced valve is connected
const int vpiState   = 1003;  // state of referenced valve
const int vpiTime    = 1004;  // time of valve event
const int vpiVolume  = 1005;  // loop volume
const int vpiLoadTime   = 1006;  // time for blowing sample loop with sample gas
const int vpiInjectTime = 1007;  // time for connecting sample loop to inlet
const int vpiCount	 = -1;

#ifdef __cplusplus
}
#endif

#pragma pack(pop)

#endif
// end of file
