unit expmain;

interface
uses
  baseconv,cnvtypes,ucintf;

type
  TExpFormat=class(TbaseConv)
  public
    class function FormatName:utf8string;override;
    class function FormatFlags:integer;override;
    function Imp(hSp:hSPEC;const Fname:PChar):integer;override;
    function Exp(hSp:hSPEC;const Fname:PChar):integer;override;
  end;

implementation
uses SysUtils,Classes,ucimp;

{ TExpFormat }

function TExpFormat.Imp(hSp: hSPEC; const Fname: PChar): integer;
begin
  Result:=CNV_FAIL;
end;


function TExpFormat.Exp(hSp: hSPEC; const Fname: PChar): integer;
var
  fs:TStream;
  vv:variant;
  zSp:HSPEC;
  i,j,lays,size,vt:integer;
  bs:string;
begin
  Result:=CNV_FAIL;
  try
    try
      fs:=TFileStream.Create(FName,fmCreate);

      if gUc.GetPropValue(hSp,1,'zSpec',vv) then
      begin
        ptrUint(zSp):=ptrUint(vv);
      end else exit;

      if (zSp=HINVALID) then exit; // no spectra, just chromatogram

      if not guc.GetPropValue(zSp,-1,'VectorType',vv) then exit;
      vt:=vv;
      if not guc.GetPropValue(zSp,-1,'Layers',vv) then exit;
      lays:=vv;
      for i:=1 to lays do
      begin
        if not guc.GetPropValue(zSp,i,'Size',vv) then exit;
        size:=vv;
        bs:='';
        for j:=1 to size do
        bs:=bs+format('(%g;%g);',[guc.GetXData(zSp,i,j),guc.GetData(zSp,i,j)]);

        bs:=bs+sLineBreak;
        fs.Write(bs[1],length(bs));

      end;

      Result:=CNV_OK;


    except
      on E:Exception do
        writeln('Error!: ',E.Message);
    end;
  finally
    fs.free;
  end;
end;

class function TExpFormat.FormatFlags: integer;
begin
  Result:=FLAG_WRITE;
end;

class function TExpFormat.FormatName: utf8string;
begin
  Result:='Export all spectra ast Text (*.zzz)|*.zzz';
end;


initialization
  CnvFact.Register(TExpFormat);
end.
